#include <windows.h> 
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h> 

#define FUNC __declspec(dllimport) __stdcall
extern "C" HANDLE FUNC OpenHidHandle(unsigned short vendor_id, unsigned short product_id);
extern "C" void FUNC ReadReport(HANDLE handle,unsigned char *InputReport,int *len);
extern "C" void FUNC WriteReport(HANDLE handle,unsigned char *OutputReport, int *len);
extern "C" void FUNC CloseHidHandle(HANDLE handle);

HANDLE hRsDevHandle;

const USHORT VID = 0x04d8; // Tangent Devices (?)
const USHORT PID = 0xfdcf; // CP300 (?)

#define MAXREPORTSIZE 381

int		InputLength,OutputLength;
unsigned char	InputReport[MAXREPORTSIZE];
unsigned char	OutputReport[MAXREPORTSIZE];

unsigned char	button1,button2,button3,button4,button5,button6;
unsigned char	Ax;
unsigned char	wave_loop_flag;
unsigned char	wave_in_use;
unsigned char	Tx,Ty;
unsigned char	Wheel;

void Wave_Remote_Input(void);
int Wave_Remote_check(void);

void Sleep2(int msec)
{
	LARGE_INTEGER f;
	LARGE_INTEGER t1,t2;
	double t;
	QueryPerformanceFrequency(&f);
	QueryPerformanceCounter(&t1);
	while (1) {
		QueryPerformanceCounter(&t2);
		t = (double)t2.QuadPart - (double)t1.QuadPart;
		t /= (double)f.QuadPart;
		t *= 1000;
		if (t>(double)msec) { return; }
	}
}

void Wave_Remote_Input(void)
{
	unsigned char r;

	ReadReport( hRsDevHandle , InputReport, &InputLength);
	
	r = InputReport[0];
	button1=InputReport[1];
	button2=InputReport[2];
	button3=InputReport[3];
	button4=InputReport[4];
	button5=InputReport[5];	
	button6=InputReport[6];
	
	Tx=InputReport[20];
	Ty=InputReport[21];
	Wheel=InputReport[16];
	
}

void Wave_Remote_Input_Main(void *)
{
	// wave remote input thread
	while (wave_loop_flag) {
		wave_in_use=1;
		Wave_Remote_Input();
		Sleep(100);
	}
	wave_in_use=0;
	return;
}

uintptr_t wave_th;

int Wave_Remote_check(void)
{
	Ax=0;
	wave_loop_flag=1;
	wave_th = _beginthread( Wave_Remote_Input_Main , 0 , NULL );
	Sleep2(100);
	wave_loop_flag=0;
	return (Ax!=0);
}

void Stop_Wave_remote_th(void)
{
	if (wave_in_use==1) {
		TerminateThread( (HANDLE)wave_th , -1); // kill thread  if it stopped
	}
}

void MainLoop(void)
{
	POINT pt;
	int lx,ly;
	int bt1,bt2,bt3,bt4;
	int axn,ayn;
	bt1=0;bt2=0;bt3=0;bt4=0;

	while (1) {
		if (kbhit()) { if (getch()==0x1B) { break; } } // ESC key  to Quit
		
		Wave_Remote_Input(); // Wave Remote
		
		if ((button2&0x02)==0x02) { break; }  // ALT button  to Quit
		
		if (button2&0x40) { // O button
			if (bt1==0) { mouse_event(MOUSEEVENTF_RIGHTDOWN,0, 0, 0, NULL); bt1=1; }
		} else {
			if (bt1==1) { mouse_event(MOUSEEVENTF_RIGHTUP,0, 0, 0, NULL); bt1=0; }
		}
		if (button2&0x20) { // . button
			if (bt2==0) { mouse_event(MOUSEEVENTF_LEFTDOWN,0, 0, 0, NULL); bt2=1; }
		} else {
			if (bt2==1) { mouse_event(MOUSEEVENTF_LEFTUP,0, 0, 0, NULL); bt2=0; }
		}
		
		if(Wheel){
			if(Wheel>127){ 
				mouse_event(MOUSEEVENTF_WHEEL,0, 0, 64, 0);
			} else {
				bt3=0;
			}
		
			if(Wheel<127){ 
				if (bt4==0) { bt4=1; }
				mouse_event(MOUSEEVENTF_WHEEL,0, 0, -64, 0);
			} else {
				bt4=0;
			}
		}
		
		// move Mouse Cursor 
		GetCursorPos(&pt);
		lx = pt.x; ly = pt.y;
		axn=0; ayn=0;
		if (Tx > 127) { axn = (Tx-255)/2; }
		if (Tx < 127) { axn = (Tx)/2; }
		if (Ty > 127) { ayn = (Ty-255)/2; }
		if (Ty < 127) { ayn = (Ty)/2; }
		GetCursorPos(&pt);
		lx = pt.x; ly = pt.y;
		lx += axn; ly -= ayn;
		SetCursorPos(lx,ly);
	}
}

int main( int argc, char *argv[])
{ 
	int i;
	
	hRsDevHandle = OpenHidHandle(VID,PID);
	if ( hRsDevHandle == INVALID_HANDLE_VALUE) {
		MessageBox(0,"CP300 not found.",0,0);
		return 1;
	}
	
	if ( 1 ) {
		printf("###########################################\n");
		printf("#                                         #\n");
		printf("#   CP300 Test version 0.1                #\n");
		printf("#                  build 2010.8.26        #\n");
		printf("#                                         #\n");
		printf("###########################################\n");
		printf("\n");
		printf("Usage:\n");
		printf("   TrackBall  ... Move cursor\n");
		printf("    O button  ... Left click\n");
		printf("    . button  ... Right click\n");
		printf("       Wheel  ... Wheel \n");
		printf("  ALT button  ... Quit\n");
		printf("\n");

		MainLoop();
		
	} else {
		
		MessageBox(0,"CP300 cannot open.",0,0);
		Stop_Wave_remote_th();
	}
	CloseHidHandle( hRsDevHandle );
	return 0;
} 
